USE std;

LET size = 200;

program:
  set up drawing parameters;
  clear history;
  enter graphics mode;
  REP
    delete a line;
    draw a line;
    next line
  ENDREP.

set up drawing parameters:
  INT graphics x limit :: 800, graphics x limit :: 400;
  INT VAR xa :: random (0, graphics x limit), xb :: random (0, graphics x limit), ya :: random (0, graphics y limit), yb :: random (0, graphics y limit);
  INT VAR dxa :: random (- 5, 5), dxb :: random (- 5, 5), dya :: random (- 5, 5), dyb :: random (- 5, 5).

clear history:
  ROW size INT VAR hxa;
  ROW size INT VAR hxb;
  ROW size INT VAR hya;
  ROW size INT VAR hyb;
  INT VAR current :: 1;
  INT VAR i;
  FOR i 
  UPTO size
  REP
    hxa [i] := 0;
    hxb [i] := 0;
    hya [i] := 0;
    hyb [i] := 0
  ENDREP.

delete a line:
  color (0);
  move (hxa [current], hya [current]);
  draw (hxb [current], hyb [current]).

draw a line:
  color (7);
  move (xa, ya);
  draw (xb, yb);
  hxa [current] := xa;
  hxb [current] := xb;
  hya [current] := ya;
  hyb [current] := yb.

next line:
  xa := xa + dxa;
  IF xa < 0 OR xa > graphics x limit
  THEN
    dxa := - dxa;
    xa := xa + dxa
  FI;
  xb := xb + dxb;
  IF xb < 0 OR xb > graphics x limit
  THEN
    dxb := - dxb;
    xb := xb + dxb
  FI;
  ya := ya + dya;
  IF ya < 0 OR ya > graphics y limit
  THEN
    dya := - dya;
    ya := ya + dya
  FI;
  yb := yb + dyb;
  IF yb < 0 OR yb > graphics y limit
  THEN
    dyb := - dyb;
    yb := yb + dyb
  FI;
  current INCR 1;
  IF current = size + 1
  THEN
    current := 1
  FI.
